int lextok_val0(){return 1;}
int lextok_val1(){return  Lextok_Wood[1].lft->val();}
int lextok_val2(){return Lextok_Wood[2].lft->val() > Lextok_Wood[2].rgt->val();}
void * lextok_var3(){return &((P1 *)THIS)->philosophers; }
int lextok_val3(){return ((int)((P1 *)THIS)->philosophers); }
int lextok_val4(){return 0;}
int lextok_val5(){return  Lextok_Wood[5].lft->val();}
int lextok_val6(){return 1;}
int lextok_val7(){return !q_full(NOW
forks[((int)((P1 *)THIS)->philosophers)]);};
void * lextok_var8(){return &NOW
forks[((int)((P1 *)THIS)->philosophers)]; }
int lextok_val8(){return NOW
forks[((int)((P1 *)THIS)->philosophers)]; }
int lextok_val9(){return 1;}
int lextok_val10(){return 1;}
int lextok_val11(){return  Lextok_Wood[11].lft->val();}
int lextok_val12(){return Lextok_Wood[12].lft->val() == Lextok_Wood[12].rgt->val();}
void * lextok_var13(){return &((P1 *)THIS)->philosophers; }
int lextok_val13(){return ((int)((P1 *)THIS)->philosophers); }
int lextok_val14(){return 0;}
int lextok_val15(){return 1;}
int lextok_val16(){return 1;}
int lextok_val17(){return 1;}
int lextok_val18(){return 1;}
int lextok_val19(){
	return ((((Q0 *)qptr(NOW
forks[((P0 *)THIS)->my_id]-1))->Qlen) != 0)
	&& (Lextok_Wood[19].rgt->val()!=qrecv(NOW
forks[((P0 *)THIS)->my_id], 0, 0, 0));
}
void * lextok_var20(){return &NOW
forks[((P0 *)THIS)->my_id]; }
int lextok_val20(){return NOW
forks[((P0 *)THIS)->my_id]; }
int lextok_val21(){return 1;}
int lextok_val22(){return 1;}
int lextok_val23(){
	return ((((Q0 *)qptr(NOW
forks[((((P0 *)THIS)->my_id+1)%4)]-1))->Qlen) != 0)
	&& (Lextok_Wood[23].rgt->val()!=qrecv(NOW
forks[((((P0 *)THIS)->my_id+1)%4)], 0, 0, 0));
}
void * lextok_var24(){return &NOW
forks[((((P0 *)THIS)->my_id+1)%4)]; }
int lextok_val24(){return NOW
forks[((((P0 *)THIS)->my_id+1)%4)]; }
int lextok_val25(){return 1;}
int lextok_val26(){return 1;}
int lextok_val27(){return !q_full(NOW
forks[((P0 *)THIS)->my_id]);};
void * lextok_var28(){return &NOW
forks[((P0 *)THIS)->my_id]; }
int lextok_val28(){return NOW
forks[((P0 *)THIS)->my_id]; }
int lextok_val29(){return 1;}
int lextok_val30(){return 1;}
int lextok_val31(){return !q_full(NOW
forks[((((P0 *)THIS)->my_id+1)%4)]);};
void * lextok_var32(){return &NOW
forks[((((P0 *)THIS)->my_id+1)%4)]; }
int lextok_val32(){return NOW
forks[((((P0 *)THIS)->my_id+1)%4)]; }
int lextok_val33(){return 1;}
int lextok_val34(){return 1;}
int lextok_val35(){return 1;}
int lextok_val36(){return 1;}
